%define	name	cdrecord
%define	version	1.8.1
%define	release	2
%define	serial	4
%define	prefix	/usr

%define	major	1.8.1

Summary:	A command line CD/DVD-Recorder
Name:		%{name}
Version:	%{version}
Release:	%{release}
Serial:		%{serial}
Prefix:		%{prefix}
Copyright:	GPL
Group:		Applications/Archiving
Vendor:		Joerg Schilling <schilling@fokus.gmd.de>
URL:		http://www.fokus.gmd.de/research/cc/glone/employees/joerg.schilling/private/cdrecord.html
Source:		ftp://ftp.fokus.gmd.de/pub/unix/cdrecord/%{name}-%{version}.tar.gz
Patch0:		cdrecord-1.8-redhat.patch
BuildRoot:	/var/tmp/%{name}-%{version}

#Distribution:	Freshmeat RPMS
Packager:	Ryan Weaver <ryanw@infohwy.com>

%description
Cdrecord allows you to create CD's on a CD-Recorder (SCSI/ATAPI).
Supports data, audio, mixed, multi-session and CD+ discs etc.

%package	devel
Summary:	The libschily SCSI user level transport library
Group:		Development/Libraries
Requires:	%{name} = %{version}

%description	devel
The cdrecord distribution contains a SCSI user level transport
library.  The SCSI library is suitable to talk to any SCSI device
without having a special driver for it.

Cdrecord may be easily ported to any system that has a SCSI device
driver similar to the scg driver.

%package	cdda2wav
Summary:	Get WAV files from digital audio cd's
Group:		Applications/Sound
Obsoletes:	cdda2wav
Provides:	cdda2wav

%description	cdda2wav
A sampling utility for cdrom drives that are capable of sending audio
cd data in digital form to your host. Data can be dumped into wav or
sun format sound files. Options control the recording format (stereo/mono;
8,12,16 bits; different rates).

%package	mkisofs
Summary:	Creates a ISO9660 filesystem image
Group:		Applications/System
Obsoletes:	mkisofs
Provides:	mkisofs

%description	mkisofs
This is the mkisofs package.  It is used to create ISO 9660
file system images for creating CD-ROMs. Now includes support
for making bootable "El Torito" CD-ROMs.

%package	mkhybrid
Summary:	mkhybrid - Make ISO9660/HFS shared hybrid CD volume.
Group:		Applications/System
Obsoletes:	mkhybrid
Provides:	mkhybrid

%description	mkhybrid
mkhybrid is effectively a pre-mastering program to generate an
HFS/ISO9660/JOLIET hybrid filesystem. It is based on mkisofs(1)
and will generate a pure ISO9660 filesystem unless the HFS hybrid
command line options are given.

%prep
%setup -q -n %{name}-%{major}
%patch0 -p1 -b .redhat

%build
gmake

%install
if [ -d $RPM_BUILD_ROOT ]; then rm -rf $RPM_BUILD_ROOT; fi
gmake "INS_BASE=$RPM_BUILD_ROOT%{prefix}" install

# Installing Header files for use with devel package
rm include/scg
install -d $RPM_BUILD_ROOT%{prefix}/include/schily/scg
install -m 644 include/* $RPM_BUILD_ROOT%{prefix}/include/schily
install -m 644 incs/*/xconfig.h $RPM_BUILD_ROOT%{prefix}/include/schily
install -m 644 libscg/scg/* $RPM_BUILD_ROOT%{prefix}/include/schily/scg

# Installing default config.
mkdir -p $RPM_BUILD_ROOT/etc
install -m 644 cdrecord/cdrecord.dfl $RPM_BUILD_ROOT/etc/cdrecord.conf

# Installing mkhybrid manpage.
install -m 644 mkhybrid/mkhybrid.8 $RPM_BUILD_ROOT%{prefix}/man/man8

## Preparing doc files for RPM
# cdrecord
{
  pushd doc
  groff -Tps -man cdrecord.man > cdrecord.ps
  popd
}

# cdrecord
mkdir cdrecord-rpmdocs
cp AN-%{version} doc/cdrecord.ps Changelog README* Linux.scsi-patch \
   cdrecord/cdrecord.dfl cdrecord-rpmdocs
chmod 644 cdrecord-rpmdocs/*

# cdda2wav
mkdir cdda2wav-rpmdocs
cp AN-%{version} cdda2wav/Frontends cdda2wav/GPL cdda2wav/HOWTOUSE \
   cdda2wav/OtherProgs cdda2wav/README cdda2wav/THANKS cdda2wav/TODO \
   cdda2wav/cdda2mp3 cdda2wav/cdda2mp3.new cdda2wav/cdda_links \
   cdda2wav/pitchplay cdda2wav/readmult cdda2wav/tracknames.pl \
   cdda2wav/tracknames.txt cdda2wav/FAQ \
   cdda2wav-rpmdocs
chmod 644 cdda2wav-rpmdocs/*

# mkisofs
mkdir mkisofs-rpmdocs
cp AN-%{version} mkisofs/COPYING mkisofs/ChangeLog mkisofs/README* \
   mkisofs-rpmdocs
chmod 644 mkisofs-rpmdocs/*

# mkhybrid
mkdir mkhybrid-rpmdocs
cp AN-%{version} mkhybrid/ChangeLog.mkhybrid mkhybrid/README* \
   mkhybrid/hdisk.pl mkhybrid/mkhybrid_man.html \
   mkhybrid-rpmdocs
chmod 644 mkhybrid-rpmdocs/*

%clean
if [ -d $RPM_BUILD_ROOT ]; then rm -rf $RPM_BUILD_ROOT; fi

%files
%defattr(-,root,root)
%doc cdrecord-rpmdocs/*
%config(noreplace) /etc/cdrecord.conf
%{prefix}/bin/cdrecord
%{prefix}/bin/readcd
%{prefix}/bin/devdump
%{prefix}/bin/isoinfo
%{prefix}/bin/isodump
%{prefix}/bin/isovfy
%{prefix}/man/man1/cdrecord.1.gz
%{prefix}/man/man8/isoinfo.8.gz

%files	devel
%defattr(-,root,root)
%{prefix}/lib/libdeflt.a
%{prefix}/lib/libscg.a
%{prefix}/lib/libschily.a
%{prefix}/include/*.h
%{prefix}/include/schily

%files	cdda2wav
%defattr(-,root,root)
%doc cdda2wav-rpmdocs/*
%{prefix}/bin/cdda2wav
%{prefix}/man/man1/cdda2wav.1.gz

%files	mkisofs
%defattr(-,root,root)
%doc mkisofs-rpmdocs/*
%{prefix}/bin/mkisofs
%{prefix}/man/man8/mkisofs.8.gz

%files	mkhybrid
%defattr(-,root,root)
%doc mkhybrid-rpmdocs/*
%{prefix}/bin/mkhybrid
%{prefix}/man/man8/mkhybrid.8.gz

%changelog
* Thu Jun 29 2000 Peter Hanecak <hanecak@megaloman.sk>
  [cdrecord-1.8.1-2]
- fixed %%files (compressed man pages)

* Thu Apr 27 2000 Ryan Weaver <ryanw@infohwy.com>
  [cdrecord-1.8.1-1]
- Updated to version 1.8.1 final.
- See Previous Changelog entries for a complete picture of what has
  changed since version 1.8.

- cdrecord:
- set exit code to 0 if only fixating fails in -dummy mode
- suppress the unit not ready, long write in progress error for all
  drives - not only for Mitsumi drives
- diskid.c now gives better understandable messages for CD-RW
  in case the disk id is illegal.

- mkisofs:
- Unicode translation table for Apple available with -jcharset mac-roman

- mkhybrid:
- README.rootinfo new
- The -icon-position will now attempt to preserve folder window 
  positions, scroll bars, views etc. for Apple/Unix file formats 
  that support this information (currently CAP, EtherShare, Netatalk) 
- Added -root-info option - which works with the -icon-position 
  option to preserve the root folder window characteristics. 
  See README.rootinfo for more about this option. 
- Added 'mac-roman' to the -jcharset option. Converts Macintosh 
  Roman file name characters to the correct Joliet characters. 


* Mon Apr 24 2000 Ryan Weaver <ryanw@infohwy.com>
  [cdrecord-1.8.1a09-1]
- Cdrecord:
- Changelog updated
- New manufacturers "VICTOR COMPANY OF JAPAN, LIMITED", "VIVASTAR AG"

- Cdda2wav:
- Changelog updated
- fixed a bug in suid handling

- Mkisofs:
- Changelog updated

  [cdrecord-1.8.1a08-1]
- All:
- addes RULES link for two HP-PA models: B132L (778) and J5000 (785).
- correted illegal #undef isinf(val) in fconf.c that prevented compilation
  on HP-UX

- Mkisofs:
- Parsing of TRANS.TBL is now done adaptive instead of using hard coded numbers.
- Make TRANS.TBL wider to allow 37 char iso names, avoid hard coded values
- New option -max-iso9660-filenames allows ISO-9660 filenames to be 37 chars
  long. Use with extreme case as this may cause buffer overflows in the
  reading OS. As it mainly makes sense to use this option for HP-UX and
  IBM-AIX target systems, it should be used together with the -U option.
  This option forces to ommit ISO-9660 version numbers.
- Print a warning when mkisofs creates a filesystem that violates ISO-9660
- isoinfo now correctly detects the Joliet supplemental volume descriptor.

* Wed Apr 19 2000 Ryan Weaver <ryanw@infohwy.com>
  [cdrecord-1.8.1a07-1]
- Cdrecord:
- /etc/cdrecord.conf may now specify the cdrecord option driveropts.
  This allows to specify to use BURN-Proof mode by default.
- New file cdrecord.dfl as master for /etc/cdrecord.conf
  The special string "" is the notation for "no driver opts".
- Driver interface changed, cdrecord may now check whether a drive
  is supporting the BURN-Proof feature and reject the burnprof option
  if the drive does not support the feature.

- Cdda2wav:
- fixed several bugs with activated -w Option
- fixed a display bug for -B and the last track
- generation of info files is done only when full tracks are recorded.

- Mkisofs:
- ISO9660 filename translation code completely rewritten.
- The filename extension is now retained if possible.
  This is even valid for long filenames.
- The MAX Filename Length is now 31 (30 + '.' for files and 31 for dirs).
- Even for long and shortened filenames, the last character
  is granted to be a dot.
- New option -iso-level allows to set up the ISO9660 conformance level.
- New Option -no-iso-translate to suppress translation
  of '#' and '~'. Request accorting to a hint from
  Georgy Salnikov <sge@nmr.nioch.nsc.ru> Note that these
  characters are illegal for ISO9660. If you use this
  option, you will create an illegal CD but Microsoft
  insists in using these illegal characters.
- The option -l / -full-iso9660-filenames is now reduced to
  the documented behaviour. The undocumented behaviour is moved
  to the new option -relaxed-filenames
- New option -relaxed-filenames allows ISO9660 filenames
  to include digits, uppercase characters and all other 7 bit
  ASCII characters (no lowercase).
- New option -allow-lowercase allows ISO9660 filenames
  to contain lowercase letters in addition to the current
  set of valid characters.
- New option -allow-multidot allows ISO9660 filenames
  to contain more than one dot (leading dots are handled separately).
- New option -use-fileversion allows mkisofs to use file
  version numbers from the filesystem. This option is the default on VMS.
  The handling of file versions is now correct.
- Filenames ending in ".tar.gz" are now converted to ".tgz"
  Filenames ending in ".ps.gz" are now converted to ".psz"
  if the option -allow-multidot has not been specified.
- Obsolete option -a -all-files has been removed.
- Option -check-oldnames now correctly handles the '.' and '..' 
  pseudo directory entries in a ISO9660 directory.
- New option -sort from James Pearson sorts file locations according
  to weighting. Read README.sort for more information.
- Unified new match code from James Pearson
- New option -ucs-level to set Unicode conformance level for Joliet.
  The default has changed to level 3 again as we are now doing
  Unicode name translation. Note that this option currently only sets
  the escape sequence in the SVD. The Unicode tanslation is not
  affected.
- isoinfo now currectly prints path tables (names are not null terminated)

- Mkhybrid:
- HFS files now get the HFS_FNDR_ISINVISIBLE flag if the ISO file
  is a hidden file.

* Thu Apr 13 2000 Ryan Weaver <ryanw@infohwy.com>
  [cdrecord-1.8.1a06-1]
- All:
- fixed fconv.c to better emulate fcvt() by ecvt().
  Cygwin32 has a broken fcvt() routine, so we are
  forced to emulate fcvt() by ecvt().
- #include string.h in scsi-linux-pg.c to get a correct
  prototype for 64 bit CPU's
- cast for signed/unsigned comparison in *bytes.c and saveargs.c

- Cdrecord:
- -dao online help changed.
- New option driveropts= supports to specify driver specific options
  to cdrecord.
  To get a list of valid options, call:
    cdrecord dev=b,t,l driveropts=help -checkdrive

- New MMC driver specific option 'burnproof' and 'noburnproof'
  supports to use the new Buffer Underrun Proof (BURN-Proof) technology
  developed by Sanyo.
  IMPORTANT HINT: There is currently no check if the drive supports BURN-Proof.

- Cdda2wav:
- sound file interface adapted for mp3 encoding
  (wav.c, sunc. raw.c, aiff.c aifc.c)
- global renaming of fill_buffer -> he_fill_buffer
  (name clash between cdda2wav and lame)
- more sanity checks, check for (named) pipes and
  disable features that do not work then.
- bugfix from Christoph Wohlgemuth: last wav file
  could get wrong size with -B
- warn about currently broken and disabled MD5    checksumming

- Readcd:
- statistics now printing correct values (see fconv.c above)

- Mkisofs:
- Now using a common SCCS history file for mkisofs.8 and mkhybrid.8
  with help from James Pearson.
- Several typos in the man page corrected.
- -l -full-iso9660-filenames option online help corrected
- isorec.flags[0] now using abstract bit #defines
- New option -hidden & -hidden-list to implement ISO9660 files
  with existence (hidden) attribute for DOS based systems.
- Automatic numbering in filenames that is done to make filenames
  differ in 8.3 or 30 char iso9660 filenames is now done before the dot.
  This retains the original filename extension and makes it easier
  for non RR/Joliet users to do senseful things with the files.
- extended checks for consistence of old session when doing multi-session.
- New option -check-oldnames to force ISO-9660 name consistence check
  for all files of old session. It omitted, only filenames with
  a namelength >= 30 are checked.
- Avoid core dumps if the old session contains filenames > 33 chars.
- Increase the internal limit of the ISO-9660 filenamelength to 38
  to allow file version numbers of 32767 not to overflow internal buffers.

- Mkhybrid:
- Local strcasecmp() for systems that don't support this function

* Tue Apr  4 2000 Ryan Weaver <ryanw@infohwy.com>
  [cdrecord-1.8.1a05-1]
- All:
- Mac OS X integration now complete again with respect to compilation.
  NOTE: Apple removed the SCSI generic driver so there is curently
  no cdrecordding suppport!
  It seems that Apple is not willing to support me. Next week, I
  will give them another try....

- Cdrecord:
- New Disk manufactuerers:
  "TAROKO INTERNATIONAL CO.,LTD.",
  "UNIDISC TECHNOLOGY CO.,LTD",
  "Hong Kong Digital Technology Co.,
  Ltd.", "VIVA MAGNETICS LIMITED" 

- Cdda2wav:
- Better #ifdef's in ioctl.c
- Corrected output for CD-Text

- Readcd:
- Now using autoconfiguration for drand48()
- Late corrections in error rety mode are now handles correctly

- Mkisofs:
- Most files are now indented according to rules
- struct iso_xa_dir_record according to Yellow book
  XA disks is now properly handled.
  If the disk is 100% standard compliant (e.g. Kodak
  Photo CD's), you will get no more BAD RRVERSION messages for
  those disks. However, there seem to be a lot of CD's out that
  have junk after ISO-directory records (some null bytes
  followed by correct 14 byte XA info). At the moment,
  mkisofs is not able to deal with these disks. You will
  need to specify the -no-rr option to disable all extended
  directory atributes. At the moment, it looks like the
  problematic disks have all been created by Adaptec products.
- Correctly use PATH_MAX from limits.h instead of MAXPATHNAME
  frpm sys/param.h
- Joliet sorting is now done according to Unicode rules
  Thanks to James Pearson.
- New Option -pad pads 32kB to the end of the ISO9660
  image. This was needed as many operating systems have a read
  ahead bug and not all people will use cdrecord to write the images.
- -jcharset now implies -J

- Mkhybrid:
- Now compiles on Mac OS X without warnings.
- -hfs-creator option: type corrected

* Mon Mar 27 2000 Ryan Weaver <ryanw@infohwy.com>
  [cdrecord-1.8.1a04-1]
- All:
- Better Mac OS X integration

- Cdda2wav:
- All files checked in again into SCCS

- Mkisofs:
- -B option allows to use the special filename "..."
  to tell mkisofs to replicate the content of the last partition
  map to the end of the partition maps.
  This should allow mkisofs to be used to create Linux SILO
  boot disks for Sun Sparc systems.
  You would need an updated SILO version and call:
  	mkisofs -generic-boot SILO-BOOT_FILE -B "..." [other args]
  Note that "..." is meant literarily.
  NOTE: this was forgotten to be included in the last release!
- New option -jcharset, thanks to Georgy Salnikov <sge@nmr.nioch.nsc.ru>
  allows to specify local character set that should be translated into
  Unicode.
  This allows to use character sets different from ISO-8859-1
  (e.g. russian KOI-8 or DOS character sets)
  The default is: iso-8859-1 (UNIX) resp. code page 437 (DOS)

* Mon Mar 20 2000 Ryan Weaver <ryanw@infohwy.com>
  [cdrecord-1.8.1a03-1]
- All:
- Makefiles now have extended install rules that distinguish
  bewteen executables and other files
- Better definitions for Apple Rhapsody and Mac OS X

- Cdrecord:
- Fixed a typo in dev_mmc.c that caused an endless loop
  in send_opc_mmc()
- Support for Sanyo CD-WO CRD-R24S

- Mkisofs:
- -B option allows to use the special filename "..."
  to tell mkisofs to replicate the content of the last partition
  map to the end of the partition maps.
  This should allow mkisofs to be used to create Linux SILO
  boot disks for Sun Sparc systems.
- Replaced several literal 2048 by SECTOR_SIZE
- Better recognition code for Apple Rhapsody
- Better error messages
- New options -hfs-type & -hfs-creator for mkhybrid code
- Included a patch from "Artem Hodyush" <artem@duma.gov.ru>
  that should fix all bugs that are related to
  Deep Directory Relocation with Rock Ridge and multi-session
- multi.c now correctly indented and conforming to schily
  programming rules.

- Mkhybrid:
- apple.c, apple.h, desktop.c, mac_label.c, mac_label.h, mactypes.h,
  volume.c now correctly indented and conforming to schily programming rules.

* Wed Mar 15 2000 Ryan Weaver <ryanw@infohwy.com>
  [cdrecord-1.8.1a02-2]
- Added Patch to fix core dump when using mmc drives.
- Fixed link to cdrecord.h in mkhybrid dir.
- Added mkhybrid subpackage until mkhybrid is merged with mkisofs.

* Tue Mar  7 2000 Ryan Weaver <ryanw@infohwy.com>
  [cdrecord-1.8.1a02-1]
- All:
- Fix for config.sub to handle newer HP-PA machines

- Cdrecord:
- Ignore illegal command error for send OPC, it is an optional command

- Cdda2wav:
- fixed TOC display for cd extra discs.
  now it is consistent with the output formatted for gui
- now detects cactus data shield copy protection and
  disables ISRC and index scans for an extended drive live
- disabled generation of .cddb and .cdindex files for xcdroast
- added a line to display the inquiry result for easier debugging
- added additional output for detection of MMC-drives
- increased SCSI timeout to 300 seconds
- added verbose output for ioctl()'ed methods (with -V)
- fixed index scanning with ioctl under Linux
- disabled the CDROMSTART ioctl in play_at method (made index
  scanning under FreeBSD very slow.

- Mkisofs:
- Fix from James Pearson for Joliet disks that will have wrong directory
  structures when listed via win32.
- First attempt to integrate the mkhyprid code from James Pearson.
  To make sure that no new bugs are introduced, a separate binary will
  be created. This also allows to make mkisofs non-beta while keeping
  mkhybrid in beta for a while.

* Mon Feb 21 2000 Ryan Weaver <ryanw@infohwy.com>
  [cdrecord-1.8.1a01-1]
- All:
- Fixed a bug in most SCSI transport code:
  Missing curly brackets prevented scsi_close() from working corectly.
- Allow cdrecord to work correctly on Linix if only Parallel Port
  interfaces are present.
- fconv.c tries to handle HP-UX 11.x
- avoffset.c now handles both SIGSEV and SIGBUS 
  This should allow seamless compilation even if unexpected signals
  are thrown.

- Cdrecord:
- Added send_opc routine to driver interface.
  This was needed because of a Firmware bug in the Ricoh 7040 and 7060
  drives. The MMC standad requires that a drive will automatically
  perform OPC but the Ricoh drives don't do this.
- Check for sectorsize be doing a SCSI read capacity if the drive does
  not support block descriptors.
- new option -waiti lets cdrecord wait until data is available on 
  standard input before opening the SCSI driver.
  This allows cdrecord to be used for
  	mkisofs ... | cdrecord ...
  when writing new sessions to a multi session disk.
  Before it was impossible because it does not work for two programs
  to open the SCSI driver simultaneously.
- The error message "drive not ready long write in progress" is now
  handeled. Cdrecord may now be used to write in DAO mode to drives from
  Sony, Mitsumi and Goldstar.

- Cdda2wav:
- new entries in TODO list :-)
- fix magic in cdda2mp3 script
- cleanup documentation (man page)
- made -T deemphasizing automatic, when preemphasis is found
  make sure info files reflect the state of the audio file
- fix index scanning (now begins at index 1 position)
- allow failure of realtime scheduling, if run as non-root
- fix percentage display for the 100% case
- added sanity checks for nsectors and buffers settings
  now '-P1 -n1 -l1' will be adjusted as needed (with warning)
- made multiple given file names work with mixed-cd also
- moved shared memory allocation from interface.c to cdda2wav.c
  that allowed to take adjusted buffer and nsector settings into account
- removed 'SONY CD-ROM CDU625 1.0' from is-not-mmc-exception table
- added 'HITACHI CDR-7930' to the is-cdda-capable table
- added a heuristic for formerly not recognized Toshiba ATAPI drives
  like XM-5402TA
- added O_NONBLOCK when opening a cdrom drive 
  for ioctl usage under Linux
- fixed the ugly bug with the combination of -P1 and
  deemphasizing or channel swapping
- added a loop when writing samples out. This fixes
  writing to a named pipe.
- changed speed setting for MMC drives. Write speed
  is always set to 0xFFFF. The command might fail,
  since it is not mandatory. This hopefully avoids
  error messages in the stdout channel.
  Speed setting does not work fully satisfactorily yet.
- moved free_sem() to the right place in order to compile
  semshm.c even with USE_SEMAPHORES
- corrected variable names for swapped roles of parent/child
- made cd-extra detection more robust. Implemented a rough
  file system lookup for the title description file
- fixed the cdindex file generation wrt forbidden HTML characters

- Mkisofs:
- Now mkisofs is finally in SCCS.
  After a hard time, all 7 years of development are put into revision 
  control. Now future development is easier.....
- Mkisofs now closes the SCSI driver after reading the previous session.
  This allows you to run 
  	mkisofs -C ... -M ... | cdrecord ....

